Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,96 @@
+/*
+ * SuspendInWaterAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "log.hpp"
+#include "config.hpp"
+#include "World.hpp"
+
+/****** MoleculeSuspendInWaterAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeSuspendInWaterState : public ActionState {
+//public:
+//  MoleculeSuspendInWaterState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeSuspendInWaterAction::NAME[] = "suspend-in-water";
+
+MoleculeSuspendInWaterAction::MoleculeSuspendInWaterAction() :
+  Action(NAME)
+{}
+
+MoleculeSuspendInWaterAction::~MoleculeSuspendInWaterAction()
+{}
+
+Action::state_ptr MoleculeSuspendInWaterAction::performCall() {
+  molecule *mol = NULL;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  double density;
+  double volume = 0.;
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryDouble("density", &density, MapOfActions::getInstance().getDescription("density"));
+
+  if(dialog->display()) {
+    DoLog(0) && (Log() << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.");
+    if (density < 1.0) {
+      DoeLog(1) && (eLog()<< Verbose(1) << "Density must be greater than 1.0g/cm^3!" << endl);
+    } else {
+      PrepareClustersinWater(World::getInstance().getConfig(), mol, volume, density);  // if volume == 0, will calculate from ConvexEnvelope
+      delete dialog;
+      return Action::success;
+    }
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSuspendInWaterAction::performUndo(Action::state_ptr _state) {
+//  MoleculeSuspendInWaterState *state = assert_cast<MoleculeSuspendInWaterState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeSuspendInWaterAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeSuspendInWaterAction::canUndo() {
+  return false;
+}
+
+bool MoleculeSuspendInWaterAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeSuspendInWaterAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/SuspendInWaterAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * SuspendInWaterAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef SUSPENDINWATERACTION_HPP
+#define SUSPENDINWATERACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeSuspendInWaterAction : public Action {
+public:
+  MoleculeSuspendInWaterAction();
+  virtual ~MoleculeSuspendInWaterAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // SUSPENDINWATERACTION_HPP
Index: src/Actions/MoleculeAction/TranslateAction.cpp
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/TranslateAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,96 @@
+/*
+ * TranslateAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/TranslateAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeTranslateAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeTranslateState : public ActionState {
+//public:
+//  MoleculeTranslateState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeTranslateAction::NAME[] = "translate-mol";
+
+MoleculeTranslateAction::MoleculeTranslateAction() :
+  Action(NAME)
+{}
+
+MoleculeTranslateAction::~MoleculeTranslateAction()
+{}
+
+Action::state_ptr MoleculeTranslateAction::performCall() {
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+  Vector x;
+  bool periodic = false;
+
+  dialog->queryVector(NAME, &x, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  dialog->queryBoolean("periodic", &periodic, MapOfActions::getInstance().getDescription("periodic"));
+
+  if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Translating all ions by given vector." << endl);
+    if (periodic)
+      mol->TranslatePeriodically((const Vector *)&x);
+    else
+      mol->Translate((const Vector *)&x);
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeTranslateAction::performUndo(Action::state_ptr _state) {
+//  MoleculeTranslateState *state = assert_cast<MoleculeTranslateState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeTranslateAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeTranslateAction::canUndo() {
+  return false;
+}
+
+bool MoleculeTranslateAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeTranslateAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/TranslateAction.hpp
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/TranslateAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * TranslateAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef TRANSLATEACTION_HPP
+#define TRANSLATEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeTranslateAction : public Action {
+public:
+  MoleculeTranslateAction();
+  virtual ~MoleculeTranslateAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // TRANSLATEACTION_HPP
Index: src/Actions/MoleculeAction/VerletIntegrationAction.cpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,98 @@
+/*
+ * VerletIntegrationAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** MoleculeVerletIntegrationAction *****/
+
+// memento to remember the state when undoing
+
+//class MoleculeVerletIntegrationState : public ActionState {
+//public:
+//  MoleculeVerletIntegrationState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char MoleculeVerletIntegrationAction::NAME[] = "verlet-integrate";
+
+MoleculeVerletIntegrationAction::MoleculeVerletIntegrationAction() :
+  Action(NAME)
+{}
+
+MoleculeVerletIntegrationAction::~MoleculeVerletIntegrationAction()
+{}
+
+Action::state_ptr MoleculeVerletIntegrationAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule *mol = NULL;
+
+  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+
+  if(dialog->display()) {
+    DoLog(1) && (Log() << Verbose(1) << "Parsing forces file and Verlet integrating." << endl);
+    // TODO: sollte besser stream nutzen, nicht filename direkt (es sei denn, ist prefix), besser fuer unit test
+    char outputname[MAXSTRINGSIZE];
+    strcpy(outputname, filename.c_str());
+    if (!mol->VerletForceIntegration(outputname, *(World::getInstance().getConfig())))
+      DoLog(2) && (Log() << Verbose(2) << "File not found." << endl);
+    else
+      DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
+
+    delete dialog;
+    return Action::success;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeVerletIntegrationAction::performUndo(Action::state_ptr _state) {
+//  MoleculeVerletIntegrationState *state = assert_cast<MoleculeVerletIntegrationState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr MoleculeVerletIntegrationAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool MoleculeVerletIntegrationAction::canUndo() {
+  return false;
+}
+
+bool MoleculeVerletIntegrationAction::shouldUndo() {
+  return false;
+}
+
+const string MoleculeVerletIntegrationAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/VerletIntegrationAction.hpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * VerletIntegrationAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef VERLETINTEGRATIONACTION_HPP
+#define VERLETINTEGRATIONACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class MoleculeListClass;
+
+class MoleculeVerletIntegrationAction : public Action {
+public:
+  MoleculeVerletIntegrationAction();
+  virtual ~MoleculeVerletIntegrationAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // VERLETINTEGRATIONACTION_HPP
Index: src/Actions/ParserAction/LoadXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/ParserAction/LoadXyzAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,89 @@
+/*
+ * LoadXyzAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/ParserAction/LoadXyzAction.hpp"
+#include "Parser/XyzParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** ParserLoadXyzAction *****/
+
+//// memento to remember the state when undoing
+//
+//class ParserLoadXyzState : public ActionState {
+//public:
+//  ParserLoadXyzState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char ParserLoadXyzAction::NAME[] = "LoadXyz";
+
+ParserLoadXyzAction::ParserLoadXyzAction() :
+  Action(NAME)
+{}
+
+ParserLoadXyzAction::~ParserLoadXyzAction()
+{}
+
+Action::state_ptr ParserLoadXyzAction::performCall() {
+  string filename;
+  XyzParser parser;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryString("filename",&filename, "Filename of the xyz file");
+
+  if(dialog->display()) {
+    // parse xyz file
+    ifstream input;
+    input.open(filename.c_str());
+    if (!input.fail())
+      parser.load(&input);
+    input.close();
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr ParserLoadXyzAction::performUndo(Action::state_ptr _state) {
+//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+}
+
+Action::state_ptr ParserLoadXyzAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+}
+
+bool ParserLoadXyzAction::canUndo() {
+  return false;
+}
+
+bool ParserLoadXyzAction::shouldUndo() {
+  return false;
+}
+
+const string ParserLoadXyzAction::getName() {
+  return NAME;
+}
Index: src/Actions/ParserAction/LoadXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/ParserAction/LoadXyzAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,31 @@
+/*
+ * LoadXyzAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef LOADXYZACTION_HPP_
+#define LOADXYZACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class ParserLoadXyzAction : public Action {
+public:
+  ParserLoadXyzAction();
+  virtual ~ParserLoadXyzAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* LOADXYZACTION_HPP_ */
Index: src/Actions/ParserAction/SaveXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/ParserAction/SaveXyzAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,91 @@
+/*
+ * SaveXyzAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "Parser/XyzParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** ParserSaveXyzAction *****/
+
+//// memento to remember the state when undoing
+//
+//class ParserSaveXyzState : public ActionState {
+//public:
+//  ParserSaveXyzState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char ParserSaveXyzAction::NAME[] = "SaveXyz";
+
+ParserSaveXyzAction::ParserSaveXyzAction() :
+  Action(NAME)
+{}
+
+ParserSaveXyzAction::~ParserSaveXyzAction()
+{}
+
+Action::state_ptr ParserSaveXyzAction::performCall() {
+  string filename;
+  XyzParser parser;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryString("filename",&filename, "Filename of the xyz file");
+
+  if(dialog->display()) {
+    // store xyz file
+    ofstream output;
+    output.open(filename.c_str());
+    if (!output.fail())
+      parser.save(&output);
+    output.close();
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr ParserSaveXyzAction::performUndo(Action::state_ptr _state) {
+//  ParserSaveXyzState *state = assert_cast<ParserSaveXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserSaveXyzState(state->mol,newName));
+}
+
+Action::state_ptr ParserSaveXyzAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+//  // Undo and redo have to do the same for this action
+//  return performUndo(_state);
+}
+
+bool ParserSaveXyzAction::canUndo() {
+  return false;
+}
+
+bool ParserSaveXyzAction::shouldUndo() {
+  return false;
+}
+
+const string ParserSaveXyzAction::getName() {
+  return NAME;
+}
Index: src/Actions/ParserAction/SaveXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/ParserAction/SaveXyzAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,31 @@
+/*
+ * SaveXyzAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef SAVEXYZACTION_HPP_
+#define SAVEXYZACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class ParserSaveXyzAction : public Action {
+public:
+  ParserSaveXyzAction();
+  virtual ~ParserSaveXyzAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* SAVEXYZACTION_HPP_ */
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,109 @@
+/*
+ * ConvexEnvelopeAction.cpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#include "Actions/TesselationAction/ConvexEnvelopeAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "boundary.hpp"
+#include "linkedcell.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** TesselationConvexEnvelopeAction *****/
+
+// memento to remember the state when undoing
+
+//class TesselationConvexEnvelopeState : public ActionState {
+//public:
+//  TesselationConvexEnvelopeState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char TesselationConvexEnvelopeAction::NAME[] = "convex-envelope";
+
+TesselationConvexEnvelopeAction::TesselationConvexEnvelopeAction() :
+  Action(NAME)
+{}
+
+TesselationConvexEnvelopeAction::~TesselationConvexEnvelopeAction()
+{}
+
+Action::state_ptr TesselationConvexEnvelopeAction::performCall() {
+  string filenameConvex;
+  string filenameNonConvex;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule * mol = NULL;
+  bool Success = false;
+
+  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryString("output", &filenameConvex, MapOfActions::getInstance().getDescription("output"));
+  dialog->queryString("output", &filenameNonConvex, MapOfActions::getInstance().getDescription("output"));
+
+  if(dialog->display()) {
+    class Tesselation *TesselStruct = NULL;
+    const LinkedCell *LCList = NULL;
+    DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
+    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot convex data in " << filenameConvex << "." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Storing tecplot non-convex data in " << filenameNonConvex << "." << endl);
+    LCList = new LinkedCell(mol, 100.);
+    //FindConvexBorder(mol, LCList, argv[argptr]);
+    // TODO: Beide Funktionen sollten streams anstelle des Filenamen benutzen, besser fuer unit tests
+    FindNonConvexBorder(mol, TesselStruct, LCList, 50., filenameNonConvex.c_str());
+    //RemoveAllBoundaryPoints(TesselStruct, mol, argv[argptr]);
+    ConvexizeNonconvexEnvelope(TesselStruct, mol, filenameConvex.c_str());
+    delete(TesselStruct);
+    delete(LCList);
+    delete dialog;
+    if (Success)
+      return Action::success;
+    else
+      return Action::failure;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr TesselationConvexEnvelopeAction::performUndo(Action::state_ptr _state) {
+//  TesselationConvexEnvelopeState *state = assert_cast<TesselationConvexEnvelopeState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr TesselationConvexEnvelopeAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool TesselationConvexEnvelopeAction::canUndo() {
+  return false;
+}
+
+bool TesselationConvexEnvelopeAction::shouldUndo() {
+  return false;
+}
+
+const string TesselationConvexEnvelopeAction::getName() {
+  return NAME;
+}
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * ConvexEnvelopeAction.hpp
+ *
+ *  Created on: May 12, 2010
+ *      Author: heber
+ */
+
+#ifndef CONVEXENVELOPEACTION_HPP
+#define CONVEXENVELOPEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class TesselationListClass;
+
+class TesselationConvexEnvelopeAction : public Action {
+public:
+  TesselationConvexEnvelopeAction();
+  virtual ~TesselationConvexEnvelopeAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // CONVEXENVELOPEACTION_HPP
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,110 @@
+/*
+ * NonConvexEnvelopeAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#include "Actions/TesselationAction/NonConvexEnvelopeAction.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/MapOfActions.hpp"
+
+#include "atom.hpp"
+#include "boundary.hpp"
+#include "linkedcell.hpp"
+#include "log.hpp"
+#include "molecule.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+/****** TesselationNonConvexEnvelopeAction *****/
+
+// memento to remember the state when undoing
+
+//class TesselationNonConvexEnvelopeState : public ActionState {
+//public:
+//  TesselationNonConvexEnvelopeState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char TesselationNonConvexEnvelopeAction::NAME[] = "nonconvex-envelope";
+
+TesselationNonConvexEnvelopeAction::TesselationNonConvexEnvelopeAction() :
+  Action(NAME)
+{}
+
+TesselationNonConvexEnvelopeAction::~TesselationNonConvexEnvelopeAction()
+{}
+
+Action::state_ptr TesselationNonConvexEnvelopeAction::performCall() {
+  string filename;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+  molecule * Boundary = NULL;
+  double SphereRadius = 0;
+  bool Success = false;
+  clock_t start,end;
+
+  dialog->queryDouble(NAME, &SphereRadius, MapOfActions::getInstance().getDescription(NAME));
+  dialog->queryString("output", &filename, MapOfActions::getInstance().getDescription("output"));
+  dialog->queryMolecule("molecule-by-id", &Boundary, MapOfActions::getInstance().getDescription("molecule-by-id"));
+
+  if(dialog->display()) {
+    class Tesselation *T = NULL;
+    const LinkedCell *LCList = NULL;
+    DoLog(0) && (Log() << Verbose(0) << "Evaluating non-convex envelope of molecule." << Boundary->getId() << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Using rolling ball of radius " << SphereRadius << " and storing tecplot data in " << filename << "." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Specified molecule has " << Boundary->AtomCount << " atoms." << endl);
+    start = clock();
+    LCList = new LinkedCell(Boundary, SphereRadius*2.);
+    Success = FindNonConvexBorder(Boundary, T, LCList, SphereRadius, filename.c_str());
+    //FindDistributionOfEllipsoids(T, &LCList, N, number, filename.c_str());
+    end = clock();
+    DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
+    delete(LCList);
+    delete(T);
+    delete dialog;
+    if (Success)
+      return Action::success;
+    else
+      return Action::failure;
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr TesselationNonConvexEnvelopeAction::performUndo(Action::state_ptr _state) {
+//  TesselationNonConvexEnvelopeState *state = assert_cast<TesselationNonConvexEnvelopeState*>(_state.get());
+
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+
+  return Action::failure;
+}
+
+Action::state_ptr TesselationNonConvexEnvelopeAction::performRedo(Action::state_ptr _state){
+  // Undo and redo have to do the same for this action
+  return performUndo(_state);
+}
+
+bool TesselationNonConvexEnvelopeAction::canUndo() {
+  return false;
+}
+
+bool TesselationNonConvexEnvelopeAction::shouldUndo() {
+  return false;
+}
+
+const string TesselationNonConvexEnvelopeAction::getName() {
+  return NAME;
+}
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -0,0 +1,34 @@
+/*
+ * NonConvexEnvelopeAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef NONCONVEXENVELOPEACTION_HPP
+#define NONCONVEXENVELOPEACTION_HPP
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class TesselationListClass;
+
+class TesselationNonConvexEnvelopeAction : public Action {
+public:
+  TesselationNonConvexEnvelopeAction();
+  virtual ~TesselationNonConvexEnvelopeAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // NONCONVEXENVELOPEACTION_HPP
